#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include "Painter.h"
#include "eLevel.h"

eLevel editLevel;
eCursor editCursor;

eLevel newLevel()
{
 eLevel theLevel;
 theLevel.Size = 10;
 
 for(int i = 0; i < theLevel.Size; i++)
   for(int j = 0; j < theLevel.Size; j++)
     theLevel.Walls[i][j] = MakeWallTile(BNONE);

 return theLevel;
}

void SaveLevel()
{
 FILE* save = fopen("out.lvl", "w");      
 if(!save)
 {
  printf("Error - Cannot save level.\r\n");
  return;      
 }
 for(int j = 0; j < editLevel.Size; j++)
 {
  for(int i = 0; i < editLevel.Size; i++)
  {
   if(editLevel.Walls[i][j].Blocking == BNONE) fputc('0', save);
   else if(editLevel.Walls[i][j].Blocking == BNORTH) fputc('1', save);   
   else if(editLevel.Walls[i][j].Blocking == BEAST) fputc('2', save);
   else if(editLevel.Walls[i][j].Blocking == BSOUTH) fputc('3', save);
   else if(editLevel.Walls[i][j].Blocking == BWEST) fputc('4', save);
   else if(editLevel.Walls[i][j].Blocking == BNORTHEAST) fputc('5', save);
   else if(editLevel.Walls[i][j].Blocking == BNORTHSOUTH) fputc('6', save);
   else if(editLevel.Walls[i][j].Blocking == BNORTHWEST) fputc('7', save);
   else if(editLevel.Walls[i][j].Blocking == BEASTSOUTH) fputc('8', save);
   else if(editLevel.Walls[i][j].Blocking == BEASTWEST) fputc('9', save);
   else if(editLevel.Walls[i][j].Blocking == BSOUTHWEST) fputc('A', save);
   else if(editLevel.Walls[i][j].Blocking == BNORTHEASTSOUTH) fputc('B', save);
   else if(editLevel.Walls[i][j].Blocking == BEASTSOUTHWEST) fputc('C', save);
   else if(editLevel.Walls[i][j].Blocking == BSOUTHWESTNORTH) fputc('D', save);       
   else if(editLevel.Walls[i][j].Blocking == BWESTNORTHEAST) fputc('E', save);      
   else if(editLevel.Walls[i][j].Blocking == BALL) fputc('F', save);    
  }               
  fputc('\n', save);
 }
 for(int j = 0; j < editLevel.Size; j++)
 {
  for(int i = 0; i < editLevel.Size; i++)
  {
   if(editLevel.Walls[i][j].Colour == ISRED || editLevel.Walls[i][j].Colour == ISYELLOW ||
      editLevel.Walls[i][j].Dirty || editLevel.Walls[i][j].Hole)
   {
    int x = i;
    int y = j;
    int Colour = 0;
    int Hole = 0;
    int Dirty = 0;
    if(editLevel.Walls[i][j].Colour == ISRED) Colour = 1;
    else if(editLevel.Walls[i][j].Colour == ISYELLOW) Colour = 2;
    if(editLevel.Walls[i][j].Dirty) Dirty = 1;
    if(editLevel.Walls[i][j].Hole) Hole = 1;
    fprintf(save, "W %d %d %d %d %d\n", x, y, Colour, Dirty, Hole);
   } 
  }        
 }
 for(int j = 0; j < editLevel.Size; j++)
 {
  for(int i = 0; i < editLevel.Size; i++)
  {
   if(strcmp(PlayLayer[i][j].Name, "EMPTY") != 0)
   {
    int x = PlayLayer[i][j].X;
    int y = PlayLayer[i][j].Y;
    int Colour = 0;
    if(PlayLayer[i][j].Colour == ISRED || PlayLayer[i][j].Colour == SETRED) Colour = 1;
    else if(PlayLayer[i][j].Colour == ISYELLOW || PlayLayer[i][j].Colour == SETYELLOW) Colour = 2;
    int Move = 0;
    if(PlayLayer[i][j].Moveable) Move = 1;
    int Point = (int) PlayLayer[i][j].PointDirection;
    fprintf(save, "P %d %d %d %d %d %s\n", x, y, Colour, Move, Point, PlayLayer[i][j].Name);    
   }
  }
 }
 fclose(save);
}

eLevel LoadLevel(char* FileName)
{
 int i;
 
 eLevel theLevel; 
 theLevel.Size = 10;
 FILE* NewLevel = fopen(FileName,"r");		//This opens a File so we can read it in line by line.  

 if (!NewLevel)
 {
  printf("%s not found.\r\n", FileName);
  exit(1);
 }

 int LineCounter = 0;		//This will make sure we only count 10 lines into the Stage array.  So if there is any
 char nextLevelLine[27];	// more level data, it gets ignored.
 
 while (fgets(nextLevelLine,27,NewLevel)!=NULL && LineCounter < theLevel.Size)
 { 
  for(i = 0; i < theLevel.Size; i++)
  {
   if(nextLevelLine[i] == '0') theLevel.Walls[i][LineCounter] = MakeWallTile(BNONE);
   else if(nextLevelLine[i] == '1') theLevel.Walls[i][LineCounter] = MakeWallTile(BNORTH);
   else if(nextLevelLine[i] == '2') theLevel.Walls[i][LineCounter] = MakeWallTile(BEAST);
   else if(nextLevelLine[i] == '3') theLevel.Walls[i][LineCounter] = MakeWallTile(BSOUTH);
   else if(nextLevelLine[i] == '4') theLevel.Walls[i][LineCounter] = MakeWallTile(BWEST);
   else if(nextLevelLine[i] == '5') theLevel.Walls[i][LineCounter] = MakeWallTile(BNORTHEAST);
   else if(nextLevelLine[i] == '6') theLevel.Walls[i][LineCounter] = MakeWallTile(BNORTHSOUTH);
   else if(nextLevelLine[i] == '7') theLevel.Walls[i][LineCounter] = MakeWallTile(BNORTHWEST);
   else if(nextLevelLine[i] == '8') theLevel.Walls[i][LineCounter] = MakeWallTile(BEASTSOUTH);
   else if(nextLevelLine[i] == '9') theLevel.Walls[i][LineCounter] = MakeWallTile(BEASTWEST);
   else if(nextLevelLine[i] == 'A') theLevel.Walls[i][LineCounter] = MakeWallTile(BSOUTHWEST);
   else if(nextLevelLine[i] == 'B') theLevel.Walls[i][LineCounter] = MakeWallTile(BNORTHEASTSOUTH);
   else if(nextLevelLine[i] == 'C') theLevel.Walls[i][LineCounter] = MakeWallTile(BEASTSOUTHWEST);
   else if(nextLevelLine[i] == 'D') theLevel.Walls[i][LineCounter] = MakeWallTile(BSOUTHWESTNORTH);
   else if(nextLevelLine[i] == 'E') theLevel.Walls[i][LineCounter] = MakeWallTile(BWESTNORTHEAST);
   else if(nextLevelLine[i] == 'F') theLevel.Walls[i][LineCounter] = MakeWallTile(BALL);
  }       
  LineCounter++;
  printf("%s", nextLevelLine);	
 }
 do
 {
  if(nextLevelLine[0] == 'P')
  {
    int x, y, colour, move, point;
    char* Name = (char*)malloc(512);
    char Ind;
    sscanf(nextLevelLine, "%c %d %d %d %d %d %s", &Ind, &x, &y, &colour, &move, &point, Name);
    printf("%c %d %d %d %d %d %s\r\n", Ind, x, y, colour, move, point, Name);
    
    ColourType Col;
    if(colour == 0) Col = ISGREY;
    else if(colour == 1) Col = ISRED;
    else Col = ISYELLOW;
    
    PointAt PAt;
    
    if(point == 0) PAt = PNONE;
    else if(point == 1) PAt = PNORTH;
    else if(point == 2) PAt = PEAST;
    else if(point == 3) PAt = PSOUTH;
    else PAt = PWEST;
    
    PlayLayer[x][y] = MakeStandardTile(Name, Col, move, PAt, x, y);
  }
  else if(nextLevelLine[0] == 'W')
  {
   int x, y, colour, dirty, hole;
   char Ind;
   sscanf(nextLevelLine, "%c %d %d %d %d %d", &Ind, &x, &y, &colour, &dirty, &hole);
   printf("%c %d %d %d %d %d\r\n", Ind, x, y, colour, dirty, hole);   
   
   ColourType Col;
   if(colour == 0) Col = ISGREY;
   else if(colour == 1) Col = ISRED;
   else if(colour == 2) Col = ISYELLOW;
   
   theLevel.Walls[x][y].Colour = Col;
   theLevel.Walls[x][y].Dirty = dirty;
   theLevel.Walls[x][y].Hole = hole;
  }
 }while(fgets(nextLevelLine,27,NewLevel) != NULL);
 
 fclose(NewLevel);
 return theLevel;
}

void PrintLevel(eLevel theLevel)
{
 for(int i = 0; i < theLevel.Size; i++)
   for(int j = 0; j < theLevel.Size; j++)
   {
     PaintWall(theLevel.Walls[i][j], i+2, j+2);
     if(strcmp(PlayLayer[i][j].Name, "EMPTY") != 0) 
       PaintCharacter(PlayLayer[i][j].Name, PlayLayer[i][j].X+2, 
                      PlayLayer[i][j].Y+2, PlayLayer[i][j].Colour, PlayLayer[i][j].PointDirection);
   }
 gotoXY(editCursor.X+2, editCursor.Y+2);
 
}

void MoveWest()
{
 editCursor.X--;
 if(editCursor.X < 0) editCursor.X = 0;
 gotoXY(editCursor.X+2, editCursor.Y+2); 
}

void MoveEast()
{
 editCursor.X++;
 if(editCursor.X >= editLevel.Size) editCursor.X = editLevel.Size-1;
 gotoXY(editCursor.X+2, editCursor.Y+2); 
}

void MoveNorth()
{
 editCursor.Y--;
 if(editCursor.Y < 0) editCursor.Y = 0;
 gotoXY(editCursor.X+2, editCursor.Y+2);
}

void MoveSouth()
{
 editCursor.Y++;
 if(editCursor.Y >= editLevel.Size) editCursor.Y = editLevel.Size-1;
 gotoXY(editCursor.X+2, editCursor.Y+2); 
}

void FChangeWall()
{
 int move = editLevel.Walls[editCursor.X][editCursor.Y].Blocking + 1;
 if(move > 15) move = 15;     
 editLevel.Walls[editCursor.X][editCursor.Y] = MakeWallTile((StopType) move);
}

void BChangeWall()
{
 int move = editLevel.Walls[editCursor.X][editCursor.Y].Blocking - 1;
 if(move < 0) move = 0;     
 editLevel.Walls[editCursor.X][editCursor.Y] = MakeWallTile((StopType) move); 
}
 
void DisplayCallback()
{
  // clear the color buffer
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

  // set up camera
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective( 45, 1.0, 1.0, 6000.0 );

  glMatrixMode( GL_MODELVIEW );
  GLdouble modelview[16];
  glGetDoublev(GL_MODELVIEW_MATRIX, modelview);
  glLoadIdentity();
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);	
  glutSwapBuffers();
}

void KeyboardDown(unsigned char c, int x, int y) {
  switch (c) 
  {
    case 27:
      exit (0);
      break;
    case 'a':
      MoveWest();
      break;      
    case 's':
      MoveSouth();
      break;    
    case 'w':
      MoveNorth();
      break;    
    case 'd':
      MoveEast();
      break;
    case 'y':
      editLevel.Walls[editCursor.X][editCursor.Y].Colour = ISYELLOW; 
      break;
    case 'Y':
      PlayLayer[editCursor.X][editCursor.Y].Colour = ISYELLOW; 
      break;    
    case 'g':
      editLevel.Walls[editCursor.X][editCursor.Y].Colour = ISGREY;
      break;
    case 'G':
      PlayLayer[editCursor.X][editCursor.Y].Colour = ISGREY; 
      break;      
    case 'r':
      editLevel.Walls[editCursor.X][editCursor.Y].Colour = ISRED;
      break;
    case 'R':
      PlayLayer[editCursor.X][editCursor.Y].Colour = ISRED;
      break; 
    case 'm':
      PlayLayer[editCursor.X][editCursor.Y].Moveable = !PlayLayer[editCursor.X][editCursor.Y].Moveable;
      break;     
    case 'h':
      editLevel.Walls[editCursor.X][editCursor.Y].Hole = !editLevel.Walls[editCursor.X][editCursor.Y].Hole;
      break;
    case 'j':
      editLevel.Walls[editCursor.X][editCursor.Y].Dirty = !editLevel.Walls[editCursor.X][editCursor.Y].Dirty; 
      break;
    case ',':
      BChangeWall();  
      break;           
    case '.':
      FChangeWall();       
      break;
    case 'f':
      SaveLevel();
      printf("\n\n\n\n\n\n\n\n\n\n - Level Saved.\r\n");
      break;
    case '`':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("EMPTY", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;
    case '1':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("PID", ISGREY, true, PNONE, editCursor.X, editCursor.Y); 
       break;
    case '2':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("CRYSTAL", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;       
    case '3':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("CLOSEDEXIT", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;              
    case '4':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("ALLY", ISGREY, true, PNONE, editCursor.X, editCursor.Y); 
       break;                     
    case '5':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("GOLEM", ISGREY, true, PNONE, editCursor.X, editCursor.Y); 
       break;                            
    case '6':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("FURY", ISGREY, true, PNONE, editCursor.X, editCursor.Y); 
       break;                                   
    case '7':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("FLAME", ISGREY, true, PNONE, editCursor.X, editCursor.Y); 
       break;
    case '8':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("SWITCH", ISYELLOW, false, PNONE, editCursor.X, editCursor.Y); 
       break;       
    case '9':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("SWITCH", ISRED, false, PNONE, editCursor.X, editCursor.Y); 
       break;              
    case '0':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("TRAP", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;              
    case '!':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("ARROW", ISGREY, false, PNORTH, editCursor.X, editCursor.Y); 
       break;              
    case '@':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("ARROW", ISGREY, false, PEAST, editCursor.X, editCursor.Y); 
       break;                            
    case '#':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("ARROW", ISGREY, false, PSOUTH, editCursor.X, editCursor.Y); 
       break;                            
    case '$':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("ARROW", ISGREY, false, PWEST, editCursor.X, editCursor.Y); 
       break;                                          
    case '%':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("HVBLOCK", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;        
    case '^':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("VBLOCK", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;        
    case '&':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("HBLOCK", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;               
    case '*':
       PlayLayer[editCursor.X][editCursor.Y] = MakeStandardTile("DBLOCK", ISGREY, false, PNONE, editCursor.X, editCursor.Y); 
       break;               
  }
 PrintLevel(editLevel);   
}

void onIdle()
{

}

int main(int argc, char **argv)
{
 glutInit( &argc, argv ); 
 for(int i = 0; i < 10; i++)
   for(int j = 0; j < 10; j++)
     PlayLayer[i][j] = MakeStandardTile("EMPTY", ISGREY, false, PNONE, i, j);
 if(argc > 1) editLevel = LoadLevel(argv[1]);
 else editLevel = newLevel();

 editCursor.X = 0;
 editCursor.Y = 0; 
 ClearScreen(); 

 PrintLevel(editLevel);
 glutInitDisplayMode( GLUT_DEPTH | GLUT_RGB | GLUT_DOUBLE );
 glutInitWindowSize( 20, 20 );
 glutCreateWindow("Project 3, KourikuGL");
  // register display callback
 glutDisplayFunc( DisplayCallback );
 glutKeyboardFunc( KeyboardDown );
 glutIdleFunc(onIdle);
 glViewport( 0, 0, 700, 700 );
 glEnable( GL_DEPTH_TEST );
 
 glutMainLoop();
  
 return 0;       // never reached 
}
